/* nstack.h
 * An efficient pushdown stack for integers.
 * SRE 1 March 2000. [Seattle]
 * CVS $Id: nstack.h,v 1.2 2002/04/06 15:03:00 eddy Exp $
 *****************************************************************
 * INFERNAL - inference of RNA secondary structure alignments
 * Copyright (C) 2002 HHMI & Washington University School of Medicine
 * 
 *     This source code is freely distributed under the terms of the
 *     GNU General Public License. See the files COPYRIGHT and LICENSE
 *     for details.
 *****************************************************************
 */
#ifndef NSTACKH_INCLUDED
#define NSTACKH_INCLUDED

typedef struct nstack_s {
  int *data;			/* the data stack                           */
  int  n;			/* current (topmost) elem in data           */
  int  nalloc;			/* # of elems allocated right now           */
  int  memblock;		/* memory allocation block size, # of elems */
} Nstack_t;

Nstack_t *CreateNstack(void);
int       PushNstack(Nstack_t *ns, int x);
int       PopNstack(Nstack_t *ns,  int *x);
void      FreeNstack(Nstack_t *ns);
int       NstackIsEmpty(Nstack_t *ns);

#endif /*NSTACKH_INCLUDED*/

